Attribute VB_Name = "Martin"
Option Explicit

'Declaration of used API calls

Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Global Const WM_USER = &H400
Global Const WM_COPYDATA = &H4A


Public Type COPYDATASTRUCT
    dwData As Long           ' use this to identify the kind of message by the target application
    cbData As Long           ' number of bytes to be transferred
    lpData As Long           ' pointer address of data sended
End Type


'Declaration of used variables

Global res As Long 'error result of callings, not used yet

Global Const NoError = 0
Global Const ErrDLLNotInitialised = -1
Global Const ErrLJNotRunning = -2
Global Const ErrLJNotReady = -3
Global Const ErrLJVersionError = -4

Global Const MinLJVersion = &H2060000

Global hndLJ As Long         'LightJockey Handle
Global DmxToLJ(511) As Byte  'Array to simulate the DMX IN of LightJockey


Public Function CheckLJ() As Boolean
' check to see if LightJockey is running
'Dim hndLJ As Long     'LightJockey Handle, now global variable
Dim verLJ As Long     'LightJockey Version, must be converted to hex and then to string...

    CheckLJ = False
    hndLJ = FindWindow("TLJMainForm", vbNullString)
    
    If hndLJ = 0 Then
      res = ErrLJNotRunning
    Else
      If (SendMessage(hndLJ, WM_USER + 1502, 0&, 0&) = 1) Then     'Is LJ Ready ?
        verLJ = SendMessage(hndLJ, WM_USER + 1502, 1, 0&)
        If verLJ >= MinLJVersion Then
          CheckLJ = True ' Version check Ok
        Else
          res = ErrLJVersionError
        End If
          
      Else
        res = ErrLJNotReady
      End If
    End If

End Function

Public Sub SendDMX_IN()
' send DMX data to LightJockey's DMXin
Dim cds As COPYDATASTRUCT
' fill the structure

cds.dwData = 256             ' code that LJockey interprets as DMX IN values
cds.cbData = 511
cds.lpData = VarPtr(DmxToLJ(0))
        
'Send the data to LightJockey
SendMessage hndLJ, WM_COPYDATA, 0, cds

End Sub
